/**
  ******************************************************************************
  * @file    vk1623.c
  * @author  kevin_guo
  * @version V1.2
  * @date    05-17-2020
  * @brief   This file contains all the vk1623 functions. 
	*          ļ VK1623
  ******************************************************************************
  * @attention
  ******************************************************************************
  */	
/* Includes ------------------------------------------------------------------*/
#include "vk1623.h"
  
/* extern variables ----------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define VK1623_CLK 10 //WRźƵ,delay_nusʵ 50->10kHz 10->50kHz 5->100kHz
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
//segtab[]ӦʵʵоƬLCDߣ߼-VK1623ο·
unsigned char vk1623_segtab[VK1623_SEGNUM]={
	0,1,2,3,4,5,6,7,8,9,						//SEG0-SEG9
	10,11,12,13,14,15,16,17,18,19,	//SEG10-SEG19
	20,21,22,23,24,25,26,27,28,29,	//SEG20-SEG29															
	30,31,32,33,34,35,36,37,38,39,  //SEG30-SEG39
	40,41,42,43,44,45,46,47,			  //SEG40-SEG49
};
//LCDʵֻSEG10SEG21ʹ
//.hļVK1623_SEGNUM=12
//const unsigned char vk1623_segtab[VK1623_SEGNUM]={	
//	10,11,12,13,14,15,16,17,18,19,	//SEG10-SEG19
//	20,21,													//SEG20-SEG21
//};
//vk1623_dispramӦоƬʾRAM
unsigned char vk1623_dispram[VK1623_SEGNUM];
//Ӧvk1623_segtab[VK1623_SEGNUM]
//ʾRAM bufferʹ8λbit0->com0,bit1->com1,...,bit7->com7
//LCD ʵ  38
//1ǰλ2ʮλ3Ǹλ
/*ʾbufferlcdͼӳϵ
vk1623_dispram[VK1623_SEGNUM]=
{//com7   com6   com5     com4   com3   com2   com1     com0 //ӦоƬSEG  ӦʾRAM
	 1D,     1E,    1F,      1A,    ,     1C,    1G,      1B,  //seg0   			vk1623_dispram[0]
	 2D,     2E,    2F,      2A,    ,     2C,    2G,      2B,  //seg1   			vk1623_dispram[1]
	 3D,     3E,    3F,      3A,    ,     3C,    3G,      3B,  //seg2   			vk1623_dispram[2]
}
*/
/*8ֵ 
     A
   F   B
     G
	 E   C
	   D
*/
unsigned char shuzi_zimo[15]= //ַֺģ
{
//0    1    2    3    4    5    6    7    8    9    -    L    o    H    i 
	0xF5,0x05,0xD3,0x97,0x27,0xB6,0xF6,0x15,0xF7,0xB7,0x02,0xE0,0xC6,0x67,0x05
};
unsigned char vk1623_addrbit=7;//icramַA6-A0,
unsigned char vk1623_segi,vk1623_comi;
unsigned char vk1623_maxcom;//com8com
/* Private function prototypes -----------------------------------------------*/
/* Private function ----------------------------------------------------------*/
/*******************************************************************************
* Function Name  : delay_nus
* Description    : ʱ1uS
* Input          : n->ʱʱnuS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}
/*******************************************************************************
* Function Name  : delay_nms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nms(unsigned long int n)
{
	while(n--)
	{
		delay_nus(1000);
	}
}
/*******************************************************************************
* Function Name  : WriteClock
* Description    : WRʱ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void WriteClockVk1623(void)
{
	VK1623_WR_L(); 
	delay_nus(VK1623_CLK);
	VK1623_WR_H();	
	delay_nus(VK1623_CLK);	
}
/*******************************************************************************
* Function Name  : WriteCommand
* Description    : д
* Input          : FunctonCode->/ 
* Output         : None
* Return         : None
*******************************************************************************/
void WriteCommandVk1623(unsigned char FunctonCode)
{
	unsigned char Shift = 0x80; 
	unsigned char i;
	
	VK1623_CS_L();   //CS Ƭѡ   
	delay_nus(VK1623_CLK/2);
	VK1623_DATA_H();  
	WriteClockVk1623();
	VK1623_DATA_L();  
	WriteClockVk1623();
	VK1623_DATA_L();  
	WriteClockVk1623();

	for(i = 0; i < 8; i++) 
	{
	 if(Shift & FunctonCode) 	
		 VK1623_DATA_H(); 
	 else 
		 VK1623_DATA_L();	  

	 WriteClockVk1623();
	 Shift = Shift >> 1;
	}
  VK1623_DATA_L(); 
	WriteClockVk1623();	//һ0һλ X
  VK1623_CS_H(); 			//CS Ƭѡ  
	delay_nus(VK1623_CLK/2);
  VK1623_DATA_H(); 
}

/*******************************************************************************
* Function Name  : Write1Data
* Description    : д1SEGݵʾRAMbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* Input          : Addr->дramĵַ  
* 							 : Databuf->дram(1ֽ8bit)  
* Output         : None
* Return         : None
*******************************************************************************/
void Write1DataVk1623(unsigned char Addr,unsigned char Dat)
{
	unsigned char i; 
	unsigned char Shift;
	
	Shift = 0x40; //θ3λ ֻ5λ
	
	VK1623_CS_L();  //CS Ƭѡ
	delay_nus(VK1623_CLK/2);

	VK1623_DATA_H();  
	WriteClockVk1623();  //101
	VK1623_DATA_L();  
	WriteClockVk1623();
	VK1623_DATA_H();  
	WriteClockVk1623();

	for( i = 0; i < vk1623_addrbit; i++) 
	{   		 
		if (Addr & Shift) 
			VK1623_DATA_H(); 		
		else  
			VK1623_DATA_L();
		WriteClockVk1623();		
		Shift = Shift >> 1; 
	}
  Shift = 0x01;
  for (i = 0; i < 8; i++) 
	{

		if( Dat & Shift) 
			VK1623_DATA_H();		 
   	else  
			VK1623_DATA_L();
		WriteClockVk1623();
		Shift = Shift << 1;
	}   
  VK1623_CS_H(); //CS Ƭѡ
	delay_nus(VK1623_CLK/2);	
  VK1623_DATA_H(); 
}
/*******************************************************************************
* Function Name  : WritenData
* Description    : дnSEGݵʾRAMbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* Input          : Addr->дramʼַ  
* 							 : Databuf->дramָ(ÿֽ8bit)  
* 							 : Cnt->дramݸ
* Output         : None
* Return         : None
*******************************************************************************/
void WritenDataVk1623(unsigned char Addr,unsigned char *Databuf,unsigned char Cnt)
{
	unsigned char i,j; 
	unsigned char Shift;
	unsigned char dataval; 
	
	VK1623_CS_L();   //CS Ƭѡ 
	delay_nus(VK1623_CLK/2);

	VK1623_DATA_H();  
	WriteClockVk1623();  //101
	VK1623_DATA_L();  
	WriteClockVk1623();
	VK1623_DATA_H();  
	WriteClockVk1623();

	Shift = 0x40;
	for( i = 0; i < vk1623_addrbit; i++) 
	{   		 
		if (Addr & Shift) 
			VK1623_DATA_H(); 		
		else  
			VK1623_DATA_L();
		WriteClockVk1623();		
		Shift = Shift >> 1; 
	}
	for (j = 0; j < Cnt; j++) 
	{
		Shift = 0x01;
		dataval=*Databuf++;
		for (i = 0; i < 8; i++) 
		{
			if( dataval & Shift) 
				VK1623_DATA_H();		 
			else  
				VK1623_DATA_L();
			WriteClockVk1623();
			Shift = Shift << 1;
		}   
	}
  VK1623_CS_H();   //CS Ƭѡ
	delay_nus(VK1623_CLK/2);	 
  VK1623_DATA_H(); 
}
/*******************************************************************************
* Function Name  : Vk1623_DisAll
* Description    : SEGʾͬһݣbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* 					     : 磺0xffȫ 0x00ȫ 0x55 0xaa 0x33 
* Input          dat->дram(1ֽ8bit)  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1623_DisAll(unsigned char dat)
{
	unsigned char segi;
	unsigned char dispram[64];
	
	for(segi=0;segi<64;segi++)
	{
		dispram[segi]=dat;
	}
	WritenDataVk1623(0,dispram,48);//8bitַԶ2(ÿ4bitݵַԶ1)
}
/*******************************************************************************
* Function Name  : DisSegComOn
* Description    : 1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1623_DisSegComOn(unsigned char seg,unsigned char com)
{
		Write1DataVk1623(seg*2,(1<<com));//8bitݣÿ4bitݵַ18bitݵַҪ2
}
/*******************************************************************************
* Function Name  : DisSegComOff
* Description    : ر1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1623_DisSegComOff(unsigned char seg,unsigned char com)
{
		Write1DataVk1623(seg*2,~(1<<com));//8bitݣÿ4bitݵַ18bitݵַҪ2
}
/*******************************************************************************
* Function Name  : Enter_Standby
* Description    : ͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1623_Enter_Standby(void)
{	
	//ʹLCDOFFSYSDIS,ϵͳڵ͹״̬
	//ֻʹƬRCʱԴʱ,ʹϵͳ͹״̬
	WriteCommandVk1623(OSC_OFF);
	WriteCommandVk1623(DISP_OFF);
}
/*******************************************************************************
* Function Name  : Exit_Standby
* Description    : ˳͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1623_Exit_Standby(void)
{	
	//˳͹״̬vk1623
	WriteCommandVk1623(OSC_ON);
	WriteCommandVk1623(DISP_ON);
	vk1623_maxcom=8;	//1/4bias 8com
}
/*******************************************************************************
* Function Name  : Lowlevel_Init
* Description    : ͨGPIO
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1623_Lowlevel_Init(void)
{
	//ͨߵƽͬӵƽת·
	//˺ݿͻƬӦ޸	
	GPIO_SetMode(VK1623_CS_PORT, VK1623_CS_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1623_RD_PORT, VK1623_RD_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1623_WR_PORT, VK1623_WR_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1623_DAT_PORT, VK1623_DAT_PIN, GPIO_MODE_OUTPUT);	//ֻʾݿΪIO
//	GPIO_SetMode(VK1623_DAT_PORT, VK1623_DAT_PIN, GPIO_MODE_QUASI); //ҪΪ˫IOڶʱΪIO
		
	VK1623_CS_H();      
	VK1623_RD_H();  //RDŲߵƽ                  
	VK1623_WR_H();  
	VK1623_DATA_H(); 	
}
/*******************************************************************************
* Function Name  : Init
* Description    : ʼ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1623_Init(void)
{	
	//ܽøݿͻƬӦ޸
	Vk1623_Lowlevel_Init();
	//
	WriteCommandVk1623(OSC_ON);
	WriteCommandVk1623(DISP_ON);
	vk1623_maxcom=8;	//1/4bias 8com
	//ϵĬ(δùܹرս͹)
//	WriteCommandVk1623(BUZZ_2KHZ);
//	WriteCommandVk1623(BUZZ_4KHZ);
//	WriteCommandVk1623(BUZZ_ON);
	WriteCommandVk1623(BUZZ_OFF);
	WriteCommandVk1623(IRQ_DIS);
	WriteCommandVk1623(TIMER_DIS);
	WriteCommandVk1623(WDT_DIS);
}
/*******************************************************************************
* Function Name  : disp_3num
* Description    : ʾ3λ
* Input          dat->3λ ʮ 
* Output         : None
* Return         : None
*******************************************************************************/
void disp_3num(unsigned int dat)
{		
	unsigned dat8;
	
	dat8=dat/100%10;	//ʾλ
	vk1623_dispram[0]&=0x08;
	vk1623_dispram[0]|=shuzi_zimo[dat8];
	
	dat8=dat/10%10; 	//ʾʮλ
	vk1623_dispram[1]&=0x08;
	vk1623_dispram[1]|=shuzi_zimo[dat8];
	
	dat8=dat%10;			//ʾλ
	vk1623_dispram[2]&=0x08;
	vk1623_dispram[2]|=shuzi_zimo[dat8];
		
	if(dat<100)				//С100λʾ
	{
		vk1623_dispram[0]&=0x08;
	}
	if(dat<10) 	//С10ʮλʾ
	{
		vk1623_dispram[1]&=0x08;
	}
	//SEG11
//	Write1DataVk1623(0*2,vk1623_dispram[0]);
//	Write1DataVk1623(1*2,vk1623_dispram[1]);
//	Write1DataVk1623(2*2,vk1623_dispram[2]);
	//SEGͶ
	WritenDataVk1623(0,&vk1623_dispram[0],3);
}	
/*******************************************************************************
* Function Name  : test_Main
* Description    : 
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1623_Main(void)
{	
	Vk1623_Init();
	Vk1623_DisAll(0x00);
	while(1)
	{
		Vk1623_DisAll(0xff);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vk1623_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		disp_3num(123);           //ʾ123
		delay_nms(3000);					//ʱ3S
		
		Vk1623_DisAll(0x00);			//LCDȫ
		for(vk1623_segi=0;vk1623_segi<VK1623_SEGNUM;vk1623_segi++)//seg
		{
			for(vk1623_comi=0;vk1623_comi<vk1623_maxcom;vk1623_comi++)//com
			{
				Vk1623_DisSegComOn(vk1623_segtab[vk1623_segi],vk1623_comi);	//LCD
				delay_nms(300);				//ʱ300mS
				Vk1623_DisAll(0x00);	//LCDȫ
			}
		}
		
		Vk1623_DisAll(0xff);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		for(vk1623_segi=0;vk1623_segi<VK1623_SEGNUM;vk1623_segi++)//seg
		{
			for(vk1623_comi=0;vk1623_comi<vk1623_maxcom;vk1623_comi++)//com
			{
				Vk1623_DisSegComOff(vk1623_segtab[vk1623_segi],vk1623_comi);	//LCDر
				delay_nms(300);				//ʱ300mS
				Vk1623_DisAll(0xff);	//LCDȫ
			}
		}
		delay_nms(1000);					//ʱ1S
		
		Vk1623_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vk1623_Enter_Standby();		//͹ģʽ
		delay_nms(5000);					//ʱ5S
		
		Vk1623_Exit_Standby();		//˳͹ģʽ
	}
}
/************************END OF FILE****/
